type l = {
    user	: int;
    sys 	: int;
    nice	: int;
    idle	: int;
  }


type load = {
    ave  : l;
    cpus : l list;
}

type t = load



(* <create ()> returns a current cpu load *)
val create : unit -> t

val pack : t -> string
val unpack : string Tree.t -> t

(* <uptime ms x y> returns the uptime (<(ave, cpus)>) during latest <ms> milisecdonds by compareing <x> with <y> *)
val uptime : int -> t -> t -> float * (float list)
