let debug = true;;
let dprint x = if debug then MySys.print x else ();;
let dprintln x = if debug then MySys.println x else ();;


(****************************************************************************)


type loadbar = {
    canvas : Widget.canvas Widget.widget;
  }

type t = loadbar


(*** 顤˴ؤѥ᥿ ***)
let start_point = (10, 10);;

let bar_size = (16, 50);;

let max_ncpus  = 4;;

let node_size =
    let x = (fst bar_size) + (max_ncpus + 1) and
	y = (snd bar_size) + 2 in
    (x, y);;

let space_size =(3, 30);; 	(* ΡɤȥΡɤδ֤δֳ֤礭 *)

let max_nnodes = 32;;		(* 1¤٤ɽΡɿκ *)

let canvas_size = (800, ((snd node_size) + (snd space_size)) * 10);;

(*** ޤ ***)


let create  top =
    let c = Canvas.create ~height:(snd canvas_size) ~width:(fst canvas_size) top in
    begin 
	Tk.pack [c];
	{ canvas = c }
    end;;

let bar_color l = 
    if (l < 33.3) 
    then `Green
    else if (l < 66.7) 
    then `Yellow
    else `Red;;


let draw_bar  canvas sx sy ncpus l cpu_no =
    let bx = (fst bar_size) / ncpus and
	by = snd bar_size in  
    let x1 = sx + 1 + (bx + 1) * cpu_no and
	y1 = sy +  by in 
    let x2 = x1 + bx and
	y2 = y1 - (int_of_float ((float_of_int by) *. l /. 100.0)) in     
    let color = bar_color l in
    ignore (Canvas.create_rectangle ~x1:x1 ~y1:y1 ~x2:x2 ~y2:y2 ~fill:color ~outline:`Black canvas);;


let draw_box  canvas sx sy =
    let (nx, ny) = node_size in
    let x2 = sx + nx and
	y2 = sy + ny in
    let fill = `Color "Gray" in
    ignore (Canvas.create_rectangle ~x1:sx ~y1:sy ~x2:x2 ~y2:y2 ~fill:fill ~outline:`Black canvas);;


let draw_node  canvas (hostname, uptime, id) =
    let (st_x, st_y) = start_point and
	(sp_x, sp_y) = space_size and
	(n_x, n_y)   = node_size and
	(x, y)       = (id mod max_nnodes, id / max_nnodes) in
    let x1 = st_x + (sp_x + n_x) * x and
	y1 = st_y + (sp_y + n_y) * y in
    let () = draw_box canvas x1 y1 in
    let () = 
	let l' = MyList.upto (function x -> x) 0 (List.length (snd uptime)) in
	let ncpus = List.length (snd uptime) in
	List.iter2 (draw_bar canvas (x1 + 1) (y1 +1) ncpus) (snd uptime) l'
    in
    let () =
	let s = try
	    let _ = Str.search_forward (Str.regexp "[0-9]+") hostname 0 in
	    let s = String.sub hostname 0 1 in
	    let s' = Str.matched_string hostname in
	    (if s = "t" 
	    then
		((String.sub s' 2 1) ^ (String.sub s' 4 2))
	    else 
		s ^ s'
	    )
	with _ -> (try  (String.sub hostname 0 3) with _ -> "xxx")
	in
	let () = 
	    ignore (Canvas.create_rectangle ~x1:(x1) ~y1:(y1 + n_y) ~x2:(x1 + n_x) ~y2:(y1 + n_y + 10) 
		      ~fill:(`Color "#dfdfdf") 
		      ~outline:(`Color "#dfdfdf") 
		      canvas)
	in
	ignore (Canvas.create_text ~x:(x1 + 10) ~y:(y1 + n_y) ~anchor:`N ~fill:`Black ~text:s canvas) 
    in
    ();;
    

let draw  x old_stable stable =
    let l =
	let old_l = Stable.to_list old_stable and
	    new_l = Stable.to_list stable in
	Stat.diff old_l new_l 
    in
    List.iter (draw_node x.canvas) l;;

