let my_int_to_string =
    let l = [""; "K"; "M"; "G"] in
    let rec f  l x =
	if x < 1000
	then (string_of_int x) ^ (List.hd l) 
	else f  (List.tl l) (x / 1000)
    in
    f l;;


(********************************************************************************)


let check  () =
    let chnl = open_in "/proc/meminfo" in
    let x =
	let () = ignore (input_line chnl) in 
	let f  _ m1 m2 m3 _ _ _ = (m1, m2, m3) in
	Scanf.fscanf chnl "%s %d %d %d %d %d %d" f
    in
    let () = close_in chnl in
    x;;


let print_minfo  (total, used, free) = 
    begin
	Printf.printf "total=%s, used=%s, free=%s\n" 
	  (my_int_to_string total)
	  (my_int_to_string used)
	  (my_int_to_string free);
	flush stdout
    end;;


let rec loop  () =
    let x = check () in
    begin
	print_minfo x;
	Unix.sleep 1;
	loop ()
    end;;


let main = loop ();;


let _ =
    main  ();;
