let rec unfold p f g x = 
    if p x 
    then [] 
    else f x :: unfold p f g (g x);;
		 

let upto f x y = 
    unfold ((=) y) f Pervasives.succ x;;


let to_string f sep =
    let g retval x =
	let s = f x in
	match retval with
	  "" -> s
	| _ -> retval ^ sep ^ s in
    List.fold_left g "";;



let filter_option l = 
    let l' = List.filter (function Some _ -> true | None -> false) l in
    List.map (function Some x -> x | None -> failwith "MyList.filter_option") l';;


let rec fold_left f retval = function
    [] -> retval
  | h :: t -> 
      let (retval', l') = f retval (h, t) in
      fold_left f retval' l';;
          

(* $B%j%9%H(B l $B$+$i=EJ#$9$kMWAG$r=|$$$?%j%9%H$rJV$9(B *)
let rec filter_dup_sub retval f = function
    [] -> retval
  | h :: t ->
      let t' = List.filter (function x -> f x h <> 0) t and
	    retval' = h :: retval in
      filter_dup_sub retval' f t';;

let filter_dup f l =
    let l' = filter_dup_sub [] f l in
    List.rev l';;


let pack f l =
    let g res x = 
	let s = f x in
	if (String.length res) = 0
	then s
	else res ^ ";" ^ s
    in
    "(" ^ (List.fold_left g "" l) ^ ")";;
