type my_widgets =
    { top	: Widget.toplevel Widget.widget;
      lbar	: Loadbar.t;
      hosts  	: HostViewer.t;
      procs	: ProcViewer.t;
   }

type t = my_widgets


let create_stats  top = 
  let frame = Frame.create top ~borderwidth:10 in
  let hosts = HostViewer.create frame and
      procs = ProcViewer.create frame in
  begin
(*    Tk.pack ~side:`Left [hosts.HostViewer.frame; procs.ProcViewer.frame;]; *)
    Tk.pack ~side:`Left [procs.ProcViewer.frame;];
    (frame, hosts, procs)
  end;;


let create  () =
    let top   = Tk.openTk () in
    let lbar  = Loadbar.create top and
	(stats_frm, hosts, procs) = create_stats top in
  begin
    Wm.title_set top "Load Viewer";
(*    Tk.pack ~fill:`X [stats_frm];
    Tk.pack [lbar.Loadbar.canvas]; *)
    Tk.pack [stats_frm];
    Tk.pack ~side:`Left [lbar.Loadbar.canvas]; 
    { top   = top; 
      lbar  = lbar;
      hosts = hosts;
      procs = procs; }
  end;;


let draw  x old_stable stable = 
    begin
	Loadbar.draw x.lbar old_stable stable;
(*	HostViewer.draw x.hosts old_stable stable; *)
	ProcViewer.draw x.procs old_stable stable; 
    end;;
