module IntMap = MyMap.Make(Int32)
type ptable = Proc.t IntMap.t
type t = ptable


let empty = IntMap.empty;;
let add = IntMap.add;;
let find key table = try IntMap.find key table with _ -> failwith "Ptable.find";;
let find_key v table = try
    IntMap.find_key Proc.compare v table 
with _ -> failwith "Ptable.find_key";;
let remove = IntMap.remove;;
let fold = IntMap.fold;;
let of_list = IntMap.of_list;;
let to_list = IntMap.to_list;;
let to_vals = IntMap.to_vals;;
let to_keys = IntMap.to_keys;;
let to_string = IntMap.to_string Int32.to_string (function x -> x);;
 

let create_sub  utable x =
    let _ = Str.search_forward (Str.regexp "[0-9]*") x 0 in
    let s = Str.matched_string x in
    match s with
      "" -> None
    | _ -> 
	let pid = Int32.of_string x in
	let proc = Proc.create  utable pid in
	Some (pid, proc);;


let create utable =
    let x = Sys.readdir "/proc" in
    let l = Array.to_list x in
    let l' = List.map (create_sub utable) l in
    let l'' = MyList.filter_option l' in
    of_list l'';;


let pack  x = 
    let l = to_list x in
    let f (k, v) =
	"{" ^
	(Int32.to_string k) ^ ";" ^ 
	(Proc.pack v) ^
	"}"
    in
    MyList.pack f l;;
    

let unpack_sub = function
    Tree.Leaf _ -> prerr_string "Ptable.unpack_sub: leaf"; failwith "Ptable.unpack_sub"
  | Tree.Node l as x -> try
      let k = Int32.of_string (Tree.nth_elem x 0) and
	  v = Proc.unpack (List.nth l 1) in
      (k, v)
  with _ -> prerr_string "Ptable.unpack_sub: node"; failwith "Ptable.unpack_sub"
    
let unpack = function
    Tree.Leaf _ -> prerr_string "Ptable.unpack: leaf"; failwith "Ptable.unpack"
  | Tree.Node l -> try
      let l' = List.map unpack_sub l in
      of_list l'
  with _ -> prerr_string "Ptable.unpack: node"; failwith "Ptable.unpack";;
